use Carousel50;

select z.ZoneID,count(*) as Zones 
into #TempZoneIDs
from Setup_Zones as z 
join Setup_ChannelBlocks as cb
on z.ZoneID=cb.ZoneID
group by z.ZoneID;

select cb.ChannelID
into #TempChannelIDs
from Setup_ChannelBlocks as cb
where cb.ZoneID in (select ZoneID from #TempZoneIDs as t where t.Zones>1);

--zone in more than one channel block
select distinct c.ChannelName, z.ZoneID, z.ZoneName
into #regularZonesResults
from Setup_Channels as c
join Setup_ChannelBlocks as cb
on c.ChannelID=cb.ChannelID
join #TempChannelIDs as t 
on t.ChannelID=c.ChannelID
join Setup_Zones as z
on z.ZoneID=cb.ZoneID
where z.ZoneID in (select ZoneID from #TempZoneIDs as t where t.Zones>1)

select distinct a.ZoneID, count(*) as Zones
into #tempFSAZoneIDs
from FullAlert_Subscription as a
join Setup_Zones as z
on z.ZoneID=a.ZoneID
join Setup_Channels as c
on c.ChannelID=a.ChannelID
group by a.ZoneID;

select c.ChannelName, t.ZoneID, z.ZoneName
into #FSAZoneResults
from Setup_Zones as z
join #tempFSAZoneIDs as t
on t.ZoneID=z.ZoneID
join FullAlert_Subscription as a
on t.ZoneID=a.ZoneID
join Setup_Channels as c
on c.ChannelID=a.ChannelID
where t.Zones>1;

select * from #regularZonesResults
union select * from #FSAZoneResults;

drop table #TempChannelIDs;
drop table #TempZoneIDs;
drop table #tempFSAZoneIDs;
drop table #regularZonesResults
drop table #FSAZoneResults
go