--Can uncomment DROP TABLE if testing
--DROP TABLE IF EXISTS tempdb.dbo.#tempusertable, #tempusertable2, #tempusertable3;

--Create table with ids, usernames and zone ids
USE Frontdoor50;

SELECT
Frontdoor50.dbo.UserRoleDomains.UserId,
UserName,
DomainIdentifier
INTO #tempusertable
FROM Frontdoor50.dbo.UserRoleDomains

  JOIN dbo.aspnet_Users ON UserRoleDomains.UserId=dbo.aspnet_Users.UserId

--Group concat to list zone ids next to single username rows
SELECT
MIN(UserName) AS 'User',
STUFF ( ( SELECT  ',' +  p3.DomainIdentifier 
          FROM (SELECT  p2.DomainIdentifier, p2.UserName, 
          ROW_NUMBER() OVER(PARTITION BY p2.DomainIdentifier ORDER BY p2.UserName) AS SEQ
          FROM  #tempusertable p2 WHERE
          p2.UserId = p1.UserId ) p3 
          WHERE p3.seq = 1 ORDER BY p3.UserName
          FOR XML PATH('') ), 1,1,'') AS 'Zones'  
INTO #tempusertable2
FROM #tempusertable p1
GROUP BY UserId;

--Replace zone ids with names
SELECT  [User],
        STUFF( (  SELECT ', '+ CAST(ZoneName AS VARCHAR(8000)) 
                  FROM   Carousel50.dbo.Setup_Zones
                  WHERE  ',' + #tempusertable2.[Zones] + ',' LIKE '%,' + CAST(Setup_Zones.ZoneID AS VARCHAR) + ',%'
                  FOR    XML path('')
                , TYPE).value('.', 'VARCHAR(8000)'),1,1,'') 'Zone(s)'
INTO #tempusertable3
FROM #tempusertable2;

--Add last activity date and order by that
SELECT 
[User],
MAX([Zone(s)]) AS 'Zone(s)',
MAX(LastActivityDate) AS 'LastActivityDate'
FROM #tempusertable3 JOIN dbo.aspnet_Users ON #tempusertable3.[User]=dbo.aspnet_Users.UserName
GROUP BY [User]
ORDER BY [LastActivityDate];
